Home

Home > Home

HotDocs Workspace Help File

This Help file contains information you need to use HotDocs Workspace.

The HotDocs Help window is divided into three parts – the navigation bar along the top of the help window, the main help content pane to the right, and the Contents, Search and Glossary pane to the left.

Copyright © 2014 HotDocs Limited.


What is HotDocs Workspace

Home > Getting Started with Workspace > What is HotDocs Workspace?

What is HotDocs Workspace?

HotDocs Workspace is an out-of-the-box host application which enables the user to assemble documents with HotDocs Server. Workspace includes template, answer file, and user group management utilizing an SQL database.

Workspace takes a transaction-oriented approach to managing HotDocs users, groups and content (i.e. answer files and assembled documents). Upon login, Workspace presents the user with a tabbed list of groups to which the Workspace Administrator has assigned them. They are then able to use the templates allocated to their group to assemble and download documents.


Getting Started with Workspace

HotDocs Workspace is an online application you can use to produce and manage forms and documents. You access HotDocs Workspace using a web browser, where you can select a document template, supply information to populate the template, and download the completed document.

To access Workspace

  1. Open your web browser and enter the address of Workspace as provided by Workspace Administrator.
  2. At the login screen, enter your username and password and click Log In. Optionally, check Remember Me for Workspace to remember your username and password.

For security reasons, use of the Remember Me option is not recommended when accessing Workspace with a public computer.

Next Topic


System Requirements for HotDocs Workspace

Hardware Minimum Requirements

  • 2 or more processors (2 GHz or faster)

Single processor machines can work well for development and lower load production environments

  • 1GB RAM (2 GB recommended)
  • SCSI or comparable storage subsystem

Software Minimum Requirements

Your system must meet the following minimum software requirements before you can install Workspace:

Operating Systems

  • Microsoft Windows Server (2008, 2008r2, 2012, or 2012r2)

Additional Software

  • HotDocs Server 11, with the HDServerFiles Virtual directory or a HotDocs Cloud Services subscription
  • Microsoft .Net Framework 4.0
  • Microsoft Internet Information Services (IIS) 7 or later1

You must ensure that the following IIS features are installed (enabled) or you may experience errors when using Workspace:
• Common HTTP features: Static Content, HTTP Redirection
• Application Development: ASP.NET, .NET Extensibility
• Security: Basic Authentication, Request Filtering
• Management Tools: IIS Management Console, IIS Management Scripts and Tools

  • Microsoft SQL Server2 2008 to 2014 with Mixed Mode Authentication enabled (including Express editions)
  • Windows feature ASP.NET 4.5 enabled

With Microsoft Windows Server 2012 you need to manually enable ASP.NET 3.5 and 4.5, as well as .NET Extensibility 3.5 and 4.5.

Web Browsers

To access Workspace, users must have a compatible web browser installed.

 | Internet Explorer | Firefox | Safari | Chrome
Version | Version 8 and later | Version 2 and later | Version 3 and later | Version 5 and later
JavaScript | Yes | Yes | Yes | Yes
Silverlight | Yes | Yes | Yes | Yes

Development

To develop additional functionality for Workspace, your system must also have the following software installed:

  • Microsoft Visual Studio (2008 or later), with C# libraries installed
  • ASP.Net MVC (Version 4.5)

1. IIS version 7 requires IIS 6 compatibility tools installed via the add remove windows features.

2. This includes any version, including SQL Server Express. Please review capacities for specific versions before deploying to a production environment as express supports a limited database size.


Installing HotDocs Workspace

Please ensure that the target system meets the minimum system requirements for installing Workspace.

  1. Double-click the Setup executable provided by your software vendor.
  2. When the installation wizard appears, click Next to begin the setup process.
  3. On the Destination Folder screen, you can customize the installation folder for Workspace. To change the installation folder:
    1. Click the Change button.
    2. In the Change Current Destination Folder window, navigate to the required folder and click OK.

Please note that network service account is given permission to some of the directories within the installation directory.

  4. Click Next.
  5. On the Database Server screen, select a database server from the drop-down menu. If the database is not listed:
    1. Click the Browse button
    2. Select one of the listed databases and click OK.
  6. Next on the Database Server screen, select the type of authentication you want to use when logging in to the database. You can choose either Windows Authentication (using the login details of the current Windows user), or Server Authentication (using a SQL server login and password). If you select Server Authentication, you must supply a username and password in the User ID and Password fields.
  7. In the Name of database field, enter the name of the database that Workspace will use. To select an existing database:
    1. Click the Browse button.
    2. Select the database from the list and click OK.

The installer will use this database for Workspace, leaving any existing data intact.

  8. Click Next.
  9. On the Web Server Details screen, you can customize the Application Pool Name and Application Name. Changing this configuration will affect how users browse to Workspace.
  10. If necessary, you can customize the TCP Port and Site Number on the Web Server Details screen. This configuration should only be edited when Workspace is to be attached to a site that has different configuration to the default.
  11. Click Next.
  12. If you have finished configuring Workspace for installation, click Install.
  13. Once HotDocs has completed the installation, click Finish. Workspace installer will close.
  14. To access Workspace, open a web browser and navigate to http://localhost/Workspace. The default login details are Admin (username) and password (password). We recommend that you change these details after logging in to Workspace for the first time.


Home Page: Overview

The Home Page is the main interface to Workspace. It provides a list of active work items, the ability to create and edit work items, and search functions. The Home Page contains the following elements:

  1. Authentication Status bar — shows the user currently logged in to Workspace. This also provides links to:
    1. Logout — clicking this link logs the current user out of Workspace.
    2. Change Password — clicking this link opens the Change Password page.
  2. Navigation Toolbar — lists the main sections of Workspace. Click on a link to navigate to that section. Workspace shows the name of the currently displayed section in blue text.
  3. My Groups drop-down list — used to categorise work items. Click on a tab to navigate to that Group. The Administrator can customize group names. Within each Group are the functions:
    1. Quick Search — searches the items in the selected group using the entered search terms.
    2. Create a Work Item — shows a list of all available templates. Click on a template in the list to start creating a new work item.
    3. View Reports — shows a list of work item reports for this group.
    4. Advanced Search — shows an advanced search pop-up, allowing the use of complex search conditions.
  4. Item list — displays a list of all work items in the selected group.


Interviews: Overview

By providing answers to the questions in the interview, Workspace is able to create a custom document using those answers and the template you previously selected. Once you have completed the interview, Workspace saves this document and it becomes available for download.

A HotDocs interview is a series of dialogs, each containing one or more questions. Workspace creates a custom document using your answers and the template you previously selected. Once you complete the interview, Workspace assembles the final customized document from the template by merging the interview answers into the template text.

The left pane of the interview window displays an outline of the interview. As the user answers questions, the outline tracks the user's progress through the interview.

Once the user has completed the interview, the finished document is added to the current work item. The answers supplied in the interview are also saved, so that the user can update the completed document in the future without having to input all the answers again.

The HotDocs interview is displayed using either JavaScript or Microsoft Silverlight. For more details, please refer to the HotDocs Server documentation.


Answer Mapping: Overview

You can use answer mapping to populate answer fields in an interview with data retrieved from a database. Workspace can fill answer fields or you can select data yourself. For example, when entering customer details, you can open a list containing the names of all customers. When you select the required name from the list, Workspace enters the answers for the name and any related fields (e.g. customer address, phone number) into the interview.

Answer Mapping in an Interview

The answer mapping appears as a button on an interview dialog:

When you click the button, a list of answers appears in a new Answer Source window.

Creating an Answer Mapping

Workspace retrieves the list of answers provided by an answer mapping from a database and matches it to variables in the HotDocs interview. An XML File defines the relationship between the database fields / HotDocs variables, the connection string to the database, and any queries made to the database.

Administrating an Answer Mapping

You can administer answer mappings in the Mappings section of Workspace. In this section, a Template Administrator can create new answer mappings or update and download existing answer mappings.

  • Create Mapping — create a new answer mapping.
  • Download — download the XML for an existing mapping.
  • Update — update the details of an existing mapping, including Name, the Answer Mapping XML file, and the Groups to which you have allocated the mapping.


Reports: Overview

Each work item in Workspace is comprised of one or more documents, each with a set of Answers Each document within a work item has an associated set of Answers. These can be updated or downloaded as a HotDocs XML Answer File. This answer file can be used with a desktop version of HotDocs (e.g. HotDocs User or HotDocs Player) or uploaded when assembling another document with Workspace.. A report is a special document that collates a selection of answers from multiple work items into a single document. This is useful when you need to compare similar information between separate work items.

The report document is a HotDocs template containing variables with the same names as those to be collected from existing work items. For example, if a report was to collect all the Employee Name values from the Employment Agreement template, the report must contain a repeating variable with the same name, i.e. Employee Name. The report template is then uploaded to Workspace using HotDocs Developer. After upload, you need to check the Report option on the template details page.

To create a report, you must perform an Advanced Search. You then need to provide one or more conditions upon which relevant work items are selected for inclusion in the report.

Once Workspace has created a report, it is stored in a Report List, similar to the Work Items List. From this list, reports can be edited, deleted, exported as a word processor file (for example DOCX). They can be exported as a HotDocs Answer File (.anx), a Comma Separated Values (.csv) file, or as a PDF. Reports are also Versioned, allowing the user to move between older and newer versions of a report.


Templates Page: Overview

The templates page provides functionality for managing Templates. This page can only be accessed by administrators with Template Admin rights.

Click Download Configuration to configure HotDocs Developer for uploading templates to Workspace. On this page you can use the Quick Search box to search for templates by title or description.

Below that is the template list which provides the following options:

  • Edit — allows you to edit the title, description, designate the template as a report and edit the groups that have permissions to use the template.
  • Details — allows you to view the template title, description, file name, which groups have permissions to use the template, and see the work items the template is used in.
  • Delete Selected — permanently deletes the selected template.


User Page: Overview

The User Page provides functionality for managing Workspace Users. This page can only be accessed by Administrators with User Admin rights.

Click Create User to create a new user account. On this page you can use the Quick Search box to search for users by login name or fill name.

Below that is the user list which provides the following options:

  • Edit— opens the User Details page where you can change login details, admin rights, password, and available groups.
  • Details — allows you to view the user details, admin roles, groups and a list of work items which the user was the last one to access.
  • Delete Selected — permanently deletes the selected User. A User account cannot be restored once it is deleted.


User Details: Overview

The user details pages provides functionality for editing Workspace users account details. This page can only be accessed by administrators with Administration Rights.

You can edit the following information:

  • Full Name — the name with which the user is identified in Workspace.
  • Login Name — the name with which the user logs in to Workspace.
  • User is NTLM User — uses Microsoft NT LAN Manager for authentication.
  • NTLM Name — user login name for NTLM.
  • Admin Rights — check and uncheck boxes to allocate different levels of Admin Rights to the user
  • Change Password — to change the user's password, enter the new password into both fields.
  • Groups — a list of all available groups. Check a box to add the user to that group; uncheck a box to remove the user from that group.


Versions: Overview

Workspace can store multiple Versions Each time you update a document's interview, you create a new version. These are tracked by number, starting at 1. You can review previous versions by clicking on the < and > arrow links to change the version number. of each work item. Once you have created a work item, each subsequent change — adding a document or updating a set of answers — Workspace creates a new version of the work item. There is no limit to the number of versions that you can make for a work item.

By using versions, you can see where and when you have made changes to a work item, or revert to previous versions of a work item. For example, if an error has occurred when you are updating the answers in a document, you can access a previous version of the work item, containing the correct information.

Using Versions

You can navigate between different versions of the work item using the Revision Navigation buttons. This is available in the Work Item Details page.


Work Items: Overview

Workspace collects all documents (letters, forms, contracts, and so on) associated with a project together in a single unit known as a Work Item. A work item consists of one or more documents and the set of answers used to generate them. You can save, update, or delete the documents within a work item. You can add new documents to a work item at any time.

Work Item Groups

Every home page contains one or more Groups. You can use these to organise work items into different categories. For example, you may produce contracts for leasing and selling houses. To keep these two different types of work item separate, all work items concerned with leasing will go in a Leasing group. All work items concerned with selling will go in a Selling group.

To navigate between different groups, select the group you want from the My Groups drop-down list.

Each group has an assigned set of templates from which they can create work items. When you create a new work item in a group, you can select one or more templates from the set available to the group.

Work Item List

Workspace displays the work items currently available to you in the Work Items List on the Home page. Whenever your group create a new work item, workspace adds it to the list.

In the Work Items List, you can click on the title of a work item to go to the Work Item Details page. To the right of the Document name in the work item, you can click on a drop-down arrow to view the document options: Update Interview or [image] Download. If there is more than one document in the work item, the drop-down arrow will first display a list of documents to choose from.

The Workspace Administrator can customize all the other columns available on the Work Items List, selecting from the list below or creating new fields:

  • Description — Displays the description of the work item
  • Created — Displays the time the work item was created
  • Modified — Displays the time the work item was last updated
  • Last User — Displays the name of the last user to update the work item
  • Version — Displays the version widget that allows you to control which revision to display
  • Quick Actions — Displays the 4 quick action buttons:
    • Add another document to the work item
    • Edit the work item
    • Export answers
    • Delete the work item


Work Item Details Page: Overview

Each work item in Workspace has a Work Item Details page. From this page you can perform actions such as adding another document to the work item, exporting the answers, updating the interview and downloading the template. You can also view the work item history and switch between versions of the work item.

Edit Functions

You can use the buttons at the top of the screen to edit the work item:

  • Add another document — Allows you to add a new template to the work item
  • Edit title and description — Allows you to edit the title and description of a work item
  • Export answers — Exports the answers from the current version of the work item as a HotDocs Answer File (.anx)
  • Delete item — Deletes the currently selected work item

Versions

Whenever a work item is modified by a user, a new numbered Version of the work item is created. This enables users to keep track of changes made to a work item. To navigate between earlier and later versions of a work item, click the Version Navigation buttons: <, >.

Assemblies

Next to every template and document used in the work item there are two options:

  • Update Interview — Re-opens the current version of the interview and allows you to make changes
  • Download — Downloads the current version of the selected document
  • Download PDF — Downloads the current version of the selected document as a PDF

History

At this page, you can also view creation and modification details about the current work item:

  • Assembled — time a document was last assembled and the user who assembled it
  • Last Update — time the last update on the work item was made and the name of the user who performed the activity
  • Item Creation — time the work item was created and the name of the user who created it


Configuration: Overview

The Configuration section can only be accessed by the Root Admin.

HotDocs Workspace can either be hosted locally using HotDocs Server or using a cloud instance of HotDocs Server known as HotDocs Cloud Services.

You can access the Configuration Page on the Navigation bar. On this page you can choose between using HotDocs Server or Cloud Services. To switch to Cloud Services you need to enter a Subscription ID and a Signing Key. If you do not have these credential you need to contact HotDocs.

Once you have made your choice click Save.

The default cloud service is located in the EU. If you want to use a cloud service located in the US you need to contact HotDocs.


Statistics: Overview

The Statistics page in Workspace displays statistics and logging information related to Workspace usage. It has three sections: Totals, Usage, and Logging. The page is only accessible when the you turn on the UseLogging option in the FdpLoggingConfiguration section in the Workspace web.config file.

Totals

This section lists the total numbers of users, templates, and work items in Workspace.

Template Usage

This section lists the most used templates in Workspace over a period of time. Workspace determines this number by totalling the number of work items that use the template. You can select the period of time Workspace uses to calculate usage using the drop-down menu. The available options are: Weekly, Monthly, Yearly, and All Time.

Logging

This section lists a number of the most recent entries from the Workspace log file. Each log file entry records an action carried out by a Workspace user, for example: creating a new user, uploading a template, or adding a new template to a work item. You can control the number of entries displayed by selecting 10, 20 or 50 in the drop-down menu.

Logging is optional and is only in effect when you turn on the UseLogging option in the web.config file.


Add a Document

After you have created it, most work items consist of a single document. You can add additional documents to a work item, and Workspace will populate any questions common to both documents with the answers from the first. You can add as many documents to a work item as you like.

To add a document to a work item

  1. Go to the Work Item Details page. You can access this from the Home page by clicking on the title of a work item in the work item list.
  2. Click [image] Add another document.
  3. Click on the template you want to assemble from the list of templates available in the current group.
  4. This will launch the HotDocs interview. Add any additional information you need into the interview, then click Finish.


Advanced Search

The Advanced Search function allows you to search through the contents of all the answers used to generate documents. You can use the results to find specific documents or generate a report.

To use Advanced Search

  1. On the Home Page, click Advanced Search.
  2. Enter your first search criteria. It will search against both complete and partial variable names (e.g. a search for values of Name will return answers for both Employee Name and Company Name).
  3. If required, you can add as many filters as you need. To add a new search filter, click the Add a Filter link to the right of the action buttons. Click the X on the bottom of a filter to remove it.
  4. When ready, click the Search button. (For information about the other action buttons, see Create a report.)
  5. Workspace displays the search results in a list.


Answers for Multiple Documents

Within a work item, there may be multiple documents that use the same information. For example, a contract may require that a customer's name is repeated across several different documents. To ensure that information is accurate across these documents, the Flexible Document Platform stores a single answer for the customer name. The answer is then used by all documents in the work item that show the customer name. This means that changing the name in one document updates all other documents with the new name.

For this to work correctly, the same variable name must be used in every template which is to use the information.


Change your login password

To change your login password

  1. Ensure you have logged in to Workspace.
  2. The Authentication Status Bar appears at the top right of the window. Click Change Password.
  3. Enter your old and new passwords into their respective fields.
  4. Click Change Password.


Copy a Work Item

This functionality is disabled in Workspace by default. To enable this functionality, you need to edit the Workspace Web.config file. For more information, see: Configuring Copy Work Item.

Copying a work item copies all of the documents and related answers from one Work Item into a new, separate Work Item. Changes made to one Work Item will not affect the other Work Item.

To copy a work item

  1. Navigate to the home page. There is a [image] Copy button next to each work item in the Work Items List.
  2. Click the Copy button next to the Work Item you wish to copy.
  3. The Copy Work Item page appears and prompts you for a Work Item Title and Description. Fill out the fields and click Save Changes.
  4. You are returned to the Home page. The new work item appears in the Work Items List.


Create a Document

To create a document

  1. On the home page, select the Group you want from the drop-down list.
  2. Click Create Work Item.
  3. Click the name of the template you would like to use create your document. This opens the HotDocs interview for that template.
  4. Fill in your answers. For help on how the interview works, click [image] in the interview's toolbar. When you have entered all the information, click Finish.
  5. At the Work Items Details page, you can Download the document, edit your answers in the interview, or create a new version of the document by clicking Update.


Create a Report

Create a Report Template

  1. Open HotDocs Developer and click the New Template button.
  2. In the New Template dialog, select Word DOCX Template (.docx) as the type. Enter a file name and title. Click OK.
  3. The word processor opens the new template. Create new variables with the same names as those in other documents that you want to appear in the report (for example, if a document has a CustomerName_tx variable, create a new variable with the same name to have all CustomerName_tx answers appear in the report).
  4. Once you have created all the variables you want, you need to add them to a new Repeating style dialog.
  5. Open the Component Manager and click the New Component button.
  6. Select Dialog.
  7. Give the dialog a name and, from the Style drop-down list, select Repeated Series.
  8. Add the variables you created to the new dialog.
  9. Save and close the dialog.
  10. At the Component Manager click the Component File Properties button. Click on the HotDocs Server tab and check the box for Enable template for use with HotDocs Server. Click OK.
  11. Close the Component Manager. Save and close the template.

Upload the Report Template

  1. Open HotDocs Developer and right click on the Report template.
  2. Select Upload and then HotDocs Workspace.
  3. Click Upload.
  4. Check the title and description and select which groups can use this template. The click Upload.
  5. Once the template has uploaded, click Close.
  6. Open Workspace and go to the Templates page. Click on the title of your new report template.
  7. At the templates details page, check the box next to Report.
  8. Click Save.

To create a Report

  1. On the Home Page, select the Group Every Workspace User is a member of one or more Groups. These are used to organise Work Items into different categories. Each Group has an assigned set of Documents from which Work Items are created. for which the report is to be created.
  2. Click Advanced Search and enter the criteria you need to find the required Work Items.
  3. Click Create Report to create a report based on the selected items.
  4. The Report Details page appears. From this page, the report can be downloaded, edited, or deleted.
  5. Navigate back to the Home Page. Click the View Reports link to view all reports for that group. The list of reports functions in the same way as the list of Work Items.


Create a Work Item

  1. In the Navigation bar, click Home.
  2. Make sure you have selected the correct group from the drop-down list the click Create Work Item.
  3. Click on a template to add it to your new work Item. If you need to see information about the template, click the [image] Information button next to the template. If you want to upload an existing Answer File Each document within a work item has an associated Answer File. These can be updated or downloaded as a HotDocs XML Answer File. This answer file can be used with a desktop version of HotDocs (e.g. HotDocs User or HotDocs Player) or uploaded when assembling another document with Workspace. to use with the template, click the [image] Upload Answer File button.
  4. A HotDocs Interview Creating a document in Workspace involves filling out a HotDocs Interview. The interview gathers answers which are used to construct the document, but can be re-used to create other related documents, or for other uses. The interview asks questions that have been defined by a HotDocs template developer. You can learn more about HotDocs at the HotDocs website. For more information about how to use the interview, click the Help icon in the interview's toolbar while creating a document. appears. Navigate through the interview until you have completed it.
  5. Once you have finished and Workspace has processed the answer, the Work Items Details page appears, where you can view and modify the work item.


Customize Columns in the Work Item List

The customize column function creates a new column in the Work Item List, showing the answer from each work item for a selected variable.

For example, selecting the Customer Name variable shows the answer supplied for the Customer Name variable for the work item in which it appears. You can add any number of new columns to the Work Item List. Additionally, you can control the display properties (text color, image, priority) for specific answers by conditions. You can make all instances of the answer John Smith appear in red text by setting:

  • Condition to John Smith
  • Priority to 1
  • Color to Red

Alternatively, if you wish to display an image in the column instead of answer text:

  • Set the Condition and Priority as above.
  • Create a folder called UserImages in C:\Program Files\HotDocs Limited\HotDocs Workspace\Default\Content\UserImages (location may vary from default)
  • Copy the required image to the Workspace UserImages folder
  • Enter the filename for the image you wish to display in the Image field, e.g. template_status.gif

To customize the Item List Column

  1. Navigate to the Home Page.
  2. Click the Customize Columns header at the top of the Work Items List.
  3. Click [image] Add new field.
  4. Enter details for the new column in the fields:
    1. Answer — the name of the HotDocs variable you want to show the answer for.
    2. Header — the name that appears in the Header of the column. If you leave the field empty, the Header will display the answer name by default. We recommend you enter a Header name, as answers may have long or unsuitable names.
    3. Empty Value — the text that appears when the column does not have results to display.
  5. Optionally, if you wish to add a condition to the column, click [image] Add new condition and enter data into the fields.
    1. Condition — Workspace checks the data entered for the condition against all answers supplied for the selected answer variable (selected in Step 4.i).
    2. Priority — defines a priority for the condition. In the case of two or more conditions returning a match, this setting controls which condition takes precedence. Must be an integer.
    3. Image — the filename of an image file in the Workspace UserImages folder. The supplied image appears in the custom column when the condition returns a result. The Image setting takes priority over color.
    4. Color — the color in which the condition text will appear, selected from the drop-down list.


Edit a Work Item

Workspace lists work items on the Home page with a title and description. By default, the description is blank, and the title contains the phrase "New Work Item" (this might be different on your system) and the date and time of creation. You can use the Quick Search to search the text of these titles and descriptions, so you may wish to replace them with more useful information.

Some characters cannot be used in Work Item Titles. These are: semicolon (';'), greater than ('<'), less than ('>'), double quote ('"'), pipe ('|'), question mark ('?'), backslash ('\'), and asterisk ('*').

To edit a Work Item

  1. Click on the title of the work item you want to edit.
  2. Click [image] Edit title and description.
  3. Type your new title and description, and click the Save Changes button.

The new title and description will appear in the work item.


Export a Work Item

Home > Using Workspace > Export Answers from a Work Item

Export Answers from a Work Item

The [image] Export function exports the answers from the selected work item to a HotDocs XML Answer File (*.ANX). You can export either from the Export link in a work item, or by using the Export button in the Advanced Search panel.


Log In to Workspace

To Log In to Workspace

  1. Open your web browser and enter the address of Workspace as provided by your Workspace Administrator.
  2. At the login screen, enter your login name and password and click Log In. Optionally, check Remember Me for Workspace to keep you logged in on this machine until you choose to log out.

For security reasons, use of the Remember Me option is not recommended when accessing Workspace with a public computer.


Quick Search

The Quick Search function is a quick, simple search function, used for performing searches without the complex filtering provided by the Advanced Search. The Quick Search works contextually, searching on different values depending on the current Workspace section. For each section of Workspace, the Quick Search performs searches on:

  • Home Page — searches on Work Item Name, Description, Created date, and Modified Date.
  • Users — searches on Full Name and Login Name.
  • Groups — searches on Group Title and Description.
  • Templates — searches on the Template Title and Description.

In order to take advantage of the Quick Search, you may wish to edit your work items to add keywords to the title and description.

To perform a quick search

  1. Type the search term in the field with the [image] Quick Search icon.
  2. The Work Item list will filter results as you type.
  3. To clear the current search, delete the text in the Quick Search box.


Administration Rights

Workspace provides several levels of access rights for administrators. An administrator can have any of the following rights:

Admin Type | Permissions
User Admin | May access the Home, User and Groups sections. May create, edit and delete user accounts and groups.
Template Admin | May access the Home, Templates and Mappings sections. May upload templates, delete templates, and assign templates to groups. May also create, delete and edit answer mappings.
Content Admin | May access the Home section. Content Admin's can see all work items within a group. May also customize group columns.
Root Admin | May access the Home, Users, Groups, Templates, Mapping and Configuration section.

An administrator sets the admin rights during the user creation process. You can edit the rights of an existing user by editing their user details.


Create a Group

HotDocs Workspace uses groups to organise different types of work item in Workspace. Users may be assigned to one or more different groups.

To create a Group

  1. In the Navigation bar The Navigation bar is the top-level navigation menu, linking to the main sections of Workspace. It appears on every page of Workspace. Clicking on a link in the navigation bar takes the user to the selected Section., click Groups.
  2. Click Create Group.
  3. Enter a Title and Description for the group.
  4. Optionally, you can change the name used to refer to work items. Enter the new name and its plural form under Work Item Name and Work Item Plural.
  5. Under the Templates heading, check the templates you want to add to the group.
  6. Under the Users heading, check the users you want to add to the group.
  7. Click Save.


Create a User

To create a User

  1. In the Navigation bar The Navigation bar is the top-level navigation menu, linking to the main sections of Workspace. It appears on every page of Workspace. Clicking on a link in the navigation bar takes the user to the selected Section. of Workspace, click Users.
  2. Click Create User.
  3. Enter the login details as necessary:
    1. Full Name — the name identifying the user in Workspace.
    2. Login Name — the name with which the user logs in to Workspace.
    3. User is NTLM User — check if they use Microsoft NT LAN Manager for authentication when accessing Workspace.
    4. NTLM Name — user login name for NTLM.
  4. Select Admin rights for the user, if appropriate.
  5. Create Password — to create the user's password, enter the password into both fields.
  6. Groups — a list of all available groups. Check a box to add the user to that group; uncheck a box to remove the user from that group.
  7. Click Save.


Change a Users login password

Home > Administrating Workspace > Administrating Workspace > Change a User's login password

Change a User's login password

To change a user's login password

  1. In the Navigation bar The Navigation bar is the top-level navigation menu, linking to the main sections of Workspace. It appears on every page of Workspace. Clicking on a link in the navigation bar takes the user to the selected Section. of Workspace, click Users.
  2. Click the Edit button next to the user whose password you wish to change.
  3. Enter a new password into both of the Change Password fields.
  4. Click Save.


Edit a Group

To edit a Group

  1. In the Navigation bar The Navigation bar is the top-level navigation menu, linking to the main sections of Workspace. It appears on every page of Workspace. Clicking on a link in the navigation bar takes the user to the selected Section. of Workspace, click Groups.
  2. Click the Edit button next to the group you wish to edit.
  3. In the Group Details page, update the required fields.
  4. Once you have made all your changes, click Save.


Edit a User

To edit a User

  1. In the Navigation bar The Navigation bar is the top-level navigation menu, linking to the main sections of Workspace. It appears on every page of Workspace. Clicking on a link in the navigation bar takes the user to the selected Section. of Workspace, click Users.
  2. Click the Edit button next to the user you wish to edit.
  3. In the User Details page, update the required fields.
  4. Once you have made all your changes, click Save.


Mapped Variables

Workspace provides a default set of variables that you can use to:

  • Populate the interview with details of the current user
  • Change the work item title or description according to information entered into the interview

Using Mapped Variables

  1. In your template, create a variable with the name and type of one of the variables listed below.
  2. Edit the variable and on the Advanced tab un-check Ask Automatically, Warn When Unanswered, and Save In Answer File.
  3. You can use some of these variables in Computation scripts (see examples in the From Interview to the Work Item table below).
  4. Upload the template.

From the Interview to the Work Item

You should set these variables in a computation within the template.

Variable Name | Details | Example
FDP_WorkItemTitle | Text Variable. Sets the Work Item title. | SET FDP_WorkItemTitle TO "Lease Beginning " + SignedDate
FDP_WorkItemDescription | Text variable. Sets the Work Item description. | SET FDP_WorkItemDescription TO "Employment Agreement for " + EmployeeName

From the Work Item to the Interview

Workspace detects the values for these variables on loading the interview.

Variable Name | Details
FDP_LoginName | Text variable. Detects the Login name of the current user.
FDP_FullName | Text variable. Detects the Full Name of the current user.
FDP_NtlmName | Text variable. Detects the NTLM Name of the current user.
FDP_GroupTitle | Text variable. Detects the Group from which the user has accessed the document.

Example

IF FDP_LoginName = "Admin"

SET FDP_WorkItemTitle TO " (Assembled by Administrator)"

ELSE

SET FDP_WorkItemTitle TO " (Assembled by " + FDP_FullName + ")"

END IF


Upload a Template

To upload a template to Workspace

  1. In the Navigation bar The Navigation bar is the top-level navigation menu, linking to the main sections of Workspace. It appears on every page of Workspace. Clicking on a link in the navigation bar takes the user to the selected Section., click Templates.
  2. Click [image] Download Configuration and open the downloaded file. This file configures HotDocs Developer to allow uploads to your Workspace site.
  3. Open HotDocs Developer. Select one or more templates in your HotDocs Library and right-click.
  4. Select Upload, then select HotDocs Workspace.
  5. At the HotDocs Upload window, click Upload.
  6. Enter your Administrator Login details for Workspace. Click Log In.
  7. You can edit the template title and enter a description. You can also choose which groups have access to this template. If you are replacing an existing template click Replace.
  8. When you have finished, click Upload.
  9. Once the template has uploaded, click Close.

By default, there is a maximum upload limit of 32Mb. The Workspace Administrator can customize this limit.


Create an Answer Mapping

Creating an answer mapping has the following prerequisites:

  • The user creating the mapping must have Template Administrator rights for Workspace

  • HotDocs Developer application

  • Relational database software (e.g. MS SQL Server, Oracle, Access).

Before following the instructions below you should create your answer mapping database. Example steps for setting up a database using MS SQL Server can be seen here.

Part 1: Answer Mapping Integration

There are two ways to integrate Answer Mapping with a HotDocs interview: Answer Source and Event-driven integration.

Answer Source

Displays a link on a template dialog. On clicking the link, the user sees a pop-up window from which they select answers. This is similar to the Answer Source in HotDocs desktop interviews.

To add an Answer Source Integration

  1. Open HotDocs Developer and select the template in the HotDocs Library that requires an answer mapping. Edit the component file.
  2. Edit the dialog on which the Answer Mapping will appear. Create a new Dialog Element.
  3. In the Dialog Element Editor, select the Web Link style.
  4. In the URL field, enter the following URL (with the *placeholders* filled in, see bullet list below) to create the answer source link : ../AnswerSource?mappingname=*Mapping Name*&datasource=*Data Source Name*&command=*Command Name*&multiselect=*true or false*.

In this URL:

    • *Mapping Name* — a unique name for the new Answer Mapping
    • *Data Source Name* — the name of the database you want to use
    • *Command Name* — a unique Command name to tell Workspace what to run when the user selects the web link
    • *true or false* — choose true to enable multiple selection.
  5. Navigate to the Options pane and check the Display In Server Interviews option.
  6. Save the changes to the Dialog Element and close the component file.
  7. Upload this template to Workspace.

Please continue to Part 2: Create an Answer Mapping XML File.

Event-driven

When using an Event-driven integration, Workspace configures specific queries to run when certain events occur during the interview. These events can occur when the interview starts, on navigating to a dialog, on navigating away from a dialog, or when the interview ends.

To add an Event-driven Integration

  1. Open HotDocs Developer and select the template in the HotDocs Library that requires an answer mapping. Edit the component file.
  2. Create a new text variable with the name Workspace_Mapping.
  3. In the custom interview component script, add the instruction SET Workspace_Mapping TO "dialogname=* &mappingname=* &datasource=* &command=* &EventMask=*", where:
    • Dialog name — the name of the dialog to which the event applies.
    • Mapping name — the name of the mapping file uploaded to Workspace.
    • DataSource — the name of the DataSource within the mapping file.
    • Command — the name of the Answer Source command with the Data Source.
    • Event mask — a 4-bit mask that determines when Workspace should run the event. To turn on all events, use the bit mask 1111. To turn all events off, use the bit mask 0000.
      • 1st bit (1xxx) — event runs on interview start (ignores dialog name attribute)
      • 2nd bit (x1xx) — event runs on navigate to dialog
      • 3rd bit (xx1x) — event runs on navigate away from dialog
      • 4th bit (xxx1) — event runs on interview end (ignores dialog name attribute)

The template developer can also assign multiple commands per dialog / interview by setting the control variable using repeat indices, i.e.

SET Workspace_Mapping[0] TO "dialogname=* &mappingname=* &datasource=* &command=* &EventMask=*"

SET Workspace_Mapping[1] TO "dialogname=* &mappingname=* &datasource=* &command=* &EventMask=*"

SET Workspace_Mapping[2] TO "dialogname=* &mappingname=* &datasource=* &command=* &EventMask=*"

Part 2: Create an Answer Mapping XML File

Now, you must create a new Answer Mapping XML file using the Answer Mapping XML. This file specifies:

  • The relationship between the database fields and the interview answer fields
  • The connection string to the database
  • Any queries made to the database and associated filters

You can use this table to replace the red placeholders in the example XML below (using an SQL database):

Placeholder | Replace with | Example
NAME | The name of your database | employee_db
USER | The user name you use to access your database software on the server | sa
PASSWORD | The password you use to access your database software on the server | w0rkspac3
MACHINE | The name of your server machine followed by a backslash and your database program | MACHINENAME\SQLEXPRESS
COMMAND | The command name you used in your template | EmployeeSelect
TABLE | The name of your table in your database | Employee Details
COLUMN | Start with the name of the first column in your table and continue until all columns have been listed | Employee Number
VARIABLE | The name of the variable in your template that you want to map this column to | employee_number_n
TYPE | The type of variable you are mapping to | 2
PROMPT | The column heading your want to display in the interview | Employee Number

<?xml version="1.0" encoding="utf-8" ?>

<MappingData>

<DataSource ID="1" Name="NAME" Type="SQL">

<ConnectionString>provider=SQLNCLI10;user id=USER;password=PASSWORD;data source=MACHINE;initial catalog=NAME</ConnectionString>

<Command ID="1" Name="COMMAND" Type="AnswerSource">

<Query Type="Table">TABLE</Query>

<Filter></Filter>

<Mapping>

<Item FieldName="COLUMN"
 AnsName="VARIABLE" AnsType="TYPE" PrimaryKey="false" Display="true"
 Prompt="PROMPT"></Item>

<Item FieldName="COLUMN"
 AnsName="VARIABLE" AnsType="TYPE" PrimaryKey="false" Display="true"
 Prompt="PROMPT"></Item>

<!--repeat for all columns in your table-->

</Mapping>

</Command>

</DataSource>

</MappingData>

Once you have completed the XML file, you must save it by calling the Mapping Name you used in part 1.

Part 3: Add a Mapping in Workspace

  1. Login to Workspace as a template administrator. Navigate to the Mappings section.
  2. Click Create Mapping.
  3. At the Mapping Details page you can enter the following information:
    • Name — If you are using an Answer Source or Event-driven integration, you must use the Mapping Name entered in Part 1: Answer Mapping Integration. If not, enter a unique Mapping Name.
    • Filename — Click Browse to select the Answer Mapping XML file (created in Part 2) detailing the structure of the Answer Mapping.
    • Groups — select the Groups which may use this answer mapping.
  4. Click Save. The new answer mapping will appear in the answer mappings list on the Mappings page.


Answer Mapping XML

This table contains details of the XML tags used to create an answer mapping XML file, including attributes and child nodes for each tag. A completed Answer Mapping XML example appears at the end of this article.

For more information on Answer Mapping, please see:

  • Answer Mapping: Overview
  • Create an Answer Mapping
XML Tag | Details | Example

<MappingData>

The root node. <MappingData>...</MappingData>
Attributes | Attributes Description
None
Child Nodes | Child Node Description
<DataSource> | Contains details of the data source objects to be mapped.

<DataSource>

The DataSource node contains all the information for a specific connection to a data source. It will contain a connection string to the data source and one or more Command objects that define a specific command to run. Answer Mapping XML files may contain multiple Data Sources. <DataSource ID="1" Name="Northwind" Type="SQL">...</DataSource>
Attributes | Attribute Description
ID | A unique ID number for the Data Source.
Name | A unique text name for the Data Source object.
Type | Must be SQL. SQL is a database to which you can make an Ole DB query.
Child Nodes | Child Node Description
<ConnectionString> | Contains the connection string to the data source.
<Command> | A command object that runs a command to query information from a database and relate it to answers in HotDocs.

<ConnectionString>

The connection string used to access the database. <ConnectionString>provider=SQLNCLI10;user id=sa;password=sa;data source=(local)\SQLEXPRESS;initial catalog=Integration</ConnectionString>
Attributes | Attributes Description
None
Child Nodes | Child Node Description
None

<Command>

The Command node defines a specific query to the data source, including any filters, and then lists all the columns in the query with the related HotDocs answer name and type. Multiple Commands can exist in a single Answer Mapping XML file. You can make a command a:

  • A Table command — the name of the required table. The processing code will Select all from the table or view specified.
  • A Stored Procedure name
  • An SQL query

You can embed Command nodes for repeated data in HotDocs, or related data in a database. When you are embedding Command nodes, you need to make the filter type Join, to relate to the parent Command using a specific value from its parent. HotDocs only supports up to four levels of repeat, so the mapping will only allow the same and will produce a warning on more than four levels of embedded command objects.

Embedding Command nodes is only supported for the command type Table for an SQL data source.

<Command ID="1" Name="EmployeeSelect" Type="AnswerSource" Refresh="True">...</Command>
Attributes | Attribute Description
ID | A unique numeric identifier for the Command.
Name | A unique text name for the Command object.
Type

There are two types of Command:

  • Select — retrieve data from a database before the interview.
  • AnswerSource — use this Command in the Answer Source page. Not used during a read from the database either before or after the interview.
Refresh | [Optional] Either True or False. Causes the Command to re-query the answers upon use (for example, you use a Command earlier that should set an answer required by the current Command). Default value is False if not specified.
Prompt | [AnswerSource types] The prompt text that Workspace shows at the top of the Answer Source pop-up web page.
Prerequisite | [AnswerSource types] Specifies another Command item that Workspace must show before the current Command. Workspace shows the prerequisite Command and, after selection, the Answer Source page will redirect back to the current Command.
PrereqAnsName | [AnswerSource types] The Answer Name of the prerequisite value Workspace uses for the filter.
PrereqPrompt | [AnswerSource types] Prompt the prerequisite value shows in the Answer Source.
Child Nodes | Child Node Description
<Query> | Specifies the query for the Command.
<Filter> | Specifies any filters you can apply to the Query.
<Mapping> | Contains a list of the mapping Items.
<Query> The Query node specifies a query made to the database. There are three types of queries allowed:
  • Table — a table name to query.
  • Command — a specific Ole DB SQL query. If there are parameters in the query, use "?" as a placeholder for filter values that apply.
  • StoredProcedure — the name of a stored procedure. If there are required parameters, you must create it as a filter Item (see below).

The inner text of the node contains the query information, whether a Table, a Stored Procedure name, or the query text.

 <Query Type="Table">Employee</Query>
Attributes | Attribute Description
Type | One of the three types described above: Table; Command or StoredProcedure.
Child Nodes | Child Node Description
None
<Filter> | Contains one or more <Item> nodes that define filters for the Command object.
Attributes | Attribute Description
None
Child Nodes | Child Node Description
<Item> | A specific Item to apply in the filter.
<Item>
(Filter)

Defines a specific Filter Item Workspace will apply when it executes the query. The Column attribute specifies the database column on which to perform the query. After Workspace retrieves the data, it writes it to the Answer File according to the specified Answer Name and Answer Type attributes. There are two Filter Item types:

  • Answer — retrieves a value from the current set of answer values. Answer filters can define a DefaultValue attribute for a value that Workspace uses when the answer doesn't exist.
  • TableJoin — embeds a Filter Item within another Filter Item. This should never be specified for a top-level Filter node. When using TableJoin, you must specify the Column and ParentColumn attributes (see below).
<Item Name="FullName" Type="Answer" AnswerName="Employee Name" AnswerType="1" Column="FullName" DefaultValue="Andrew Seaton"></Item>
Attributes | Attribute Description
Name | A unique text name for the Filter Item object.
Type | One of the three answer types: User; Answer; or TableJoin.
AnswerName | An answer name in HotDocs used to query the data source. If the Filter Item Type is User, this is the answer name to which Workspace writes the user-input value.
AnsType

A numeric value specifying the type of the variable in the AnswerName attribute.

  • 1 (Text)
  • 2 (Number)
  • 3 (Date)
  • 5 (True / False)
  • 6 (Multiple Choice)
PrimaryKey | Either True or False. Specifies if the Column being queried is the Primary Key of the table.
Display | Either True or False. Determines whether Workspace displays the item in the Answer Source window.
Column | The name of the column in the database you want to query.
DefaultValue | The default value to use for the Filter Item, if no value is found.
Child Nodes | Child Node Description
None
<Mapping> | This contains a list of Mapping Item nodes that define the relationship between Mapping Items from the data source and HotDocs answers.
Attributes | Attribute Description
None
Child Nodes | Child Node Description
Item | Defines a specific Item Mapping, i.e. a relationship between a column/field in the data source and a HotDocs answer.
<Item> | (Mapping) The mapping Item node defines a specific relationship between the field/column name in the data source and a HotDocs Answer. The FieldName, AnsName, and AnsType must always be provided. Workspace provides additional attributes to allow for proper display in answer sources.
Attributes | Attribute Description
FieldName | The field/column name in the data source.
AnsName | The answer name in HotDocs to relate to the data source field/column.
AnsType

A numeric value specifying the type of the variable in the AnsName attribute.

  • 1 (Text)
  • 2 (Number)
  • 3 (Date)
  • 5 (True / False)
  • 6 (Multiple Choice)
PrimaryKey | Either True or False. Specifies if the column/field being mapped is the Primary Key of the table.
Prompt | [Optional] The text to display in the column header for the Item when using an Answer Mapping Command.
Display | [Optional] Either True or False. Display the column in the selection list for the Answer Mapping. Default value is False if not specified.
Child Nodes | Child Node Description
None

Example

<?xml version="1.0" encoding="utf-8" ?>

<MappingData>

<DataSource ID="1" Name="Northwind" Type="SQL">

<ConnectionString>provider=SQLNCLI10;user id=sa;password=sa;data source=(local)\SQLEXPRESS;initial catalog=Integration</ConnectionString>

<Command ID="1" Name="EmployeeSelect" Type="AnswerSource">

<Query Type="Table">Employee</Query>

<Filter></Filter>

<Mapping>

<Item FieldName="FullName"
 AnsName="Employee Name"  AnsType="1" PrimaryKey="True"
 Display="false" Prompt="Name"></Item>

<Item FieldName="Gender"
 AnsName="Employee Gender"  AnsType="6" PrimaryKey="False"
 Display="false" Prompt="Gender"></Item>

<Item FieldName="FirstName"
 AnsName="" AnsType="1" PrimaryKey="False"
 Display="true" Prompt="Firstname(s)"></Item>

<Item FieldName="Surname"
 AnsName="" AnsType="1" PrimaryKey="False"
 Display="true" Prompt="Surname"></Item>

</Mapping>

</Command>

<Command ID="2" Name="PickAndy" Type="Select" Refresh="True">

<Query Type="Table">Employee</Query>

<Filter>

<Item Name="FullName"
 Type="Answer" AnswerName="Employee Name" AnswerType="1"
 Column="FullName" DefaultValue="Andrew Seaton"></Item>

</Filter>

<Mapping>

<Item FieldName="FullName"
 AnsName="Employee Name"  AnsType="1" PrimaryKey="True"
 Display="false" Prompt="Name"></Item>

<Item FieldName="Gender"
 AnsName="Employee Gender"  AnsType="6" PrimaryKey="False"
 Display="false" Prompt="Gender"></Item>

<Item FieldName="FirstName"
 AnsName="" AnsType="1" PrimaryKey="False"
 Display="true" Prompt="Firstname(s)"></Item>

<Item FieldName="Surname"
 AnsName="" AnsType="1" PrimaryKey="False"
 Display="true" Prompt="Surname"></Item>

</Mapping>

</Command>

</DataSource>

</MappingData>


Answer Source Link

An Answer Source link is a web link dialog element which runs an Answer Mapping command when clicked. Below is an example URL for use with a web link.

For more information on Answer Mapping, please see:

  • Answer Mapping: Overview
  • Create an Answer Mapping
Command | Value | Example
mappingname | The name of the mapping. You need to enter this when creating a new answer mapping on the Answer Mappings Admin Page. You must make this name unique. | mappingname=Northwind_Integration
datasource | The name of the database the Answer Mapping will use. | datasource=Northwind
command | The name of the command in the Answer Mapping XML file you want to run upon clicking the web link. | command=CustomerSelect
multiselect | Determines if the Answer Source window will allow the user to select multiple answers. | multiselect=true

Example

../AnswerSource?mappingname=Northwind_Integration&datasource=Northwind&command=CustomerSelect&multiselect=true


Create an Answer Mapping Database Using SQL

For the following example you will need:

  • MS SQL Server Management Studio

  • ODBCAD32.exe (found on most servers by typing ODBCAD32 into the search function in the start menu).

Part one: Set up the database

  1. Open SQL Server Management Studio
  2. At the Object Explorer, right click on Databases and select New Database....
  3. Type in a Database Name and click OK. Your database will now be added to the list.
  4. At the Object Explorer, expand your new database folder.
  5. Right click on Tables and select New Table….
  6. In the Column Name, add your first column name and set the Data Type required. Press enter to add more rows for each column name and type you require. For example your first column could be “Employee Number” so the data type could be “int” and your second column could be “Employee Name” so you could select the data type “char”.
  7. Click the Save icon in the tool bar to save this table. Type in a name for your table, e.g. “Employee Details”
  8. At the Object Explorer, expand the Tables folder and right click your new table, and click on Edit Top 200 Rows.
  9. Type in the data your want your users to choose from in the interview (the changes are saved automatically).

Part 2: Set up the connection between your database and Workspace

  1. Open ODBCAD32.exe.
  2. Go to the System DSN tab and click Add.
  3. Select SQL Server and click Finish.
  4. Type in a Name and Description for your ODBC data source.
  5. In the Server drop-down list, select the SQL instance which contains your answer mapping database e.g. “MACHINENAME\SQLEXPRESS”
  6. Click Next.
  7. Choose the option With SQL Server authentication using a login ID and password entered by the user.
  8. Type in the user name and password you use to access your SQL server.
  9. Click Next on all the steps after, there is no need to change anything else.
  10. Click OK.

You now need to create the rest of the Answer Mapping.


Answer Mapping Database

This table contains details of data types Workspace uses to store answers from a HotDocs interview in a database. When you create a database mapping you should ensure that the source data types provided are compatible with these constraints otherwise Workspace will be unable to show the resulting answer:

HotDocs Answer Type | Database Data Type
Text | nvarchar(4000)
Number | decimal(18,7)
Date | datetime
True / False | bit
Multiple Choice | nvarchar(4000)


Browser Language Modules: Overview

Starting with HotDocs 10.1, the HotDocs Server JavaScript API includes a specification for creating "Browser Language Modules" (BLM). These modules allow interviews to be localized, which means that you can present the user interface text in languages other than US English. By following this specification, you can define a language module which will allow HotDocs Server to present an interview in any language.

Although you can create a language module for any language, if the language is right-to-left (such as Arabic or Hebrew), HotDocs does not currently adjust the prompt positioning and justification as would be expected for these languages.

HotDocs Server implements a BLM as a JavaScript object in the web browser’s scripting environment. This object specifies the language that it supports (for example, “en-US”), and can also contain appropriately-translated text strings necessary for the interview user interface, as well as code necessary for locale-appropriate interpreting and formatting of numeric and date values. Language module names (“en-US”) follow the same naming scheme as the .NET framework: the first (and required) part of the language module name is a 2-letter language code based on ISO 639-1, followed by an optional (and usually 2-letter) region code based on ISO 3166.

The BLM specification allows for a limited hierarchy of language modules to exist; each language module implicitly has a “parent” or “base” language module from which it inherits certain capabilities. For example, the “en-US” language module is implicitly based on the “en” language module, it would automatically inherit all the behaviors defined by its parent. The way HotDocs Server invokes language modules from within HotDocs allows a BLM module's parent module(s) to gracefully fill in any missing functionality. All browser language modules ultimately inherit from a base language module (known as “invariant”), which defines the default behavior of all language modules. So creating a HotDocs BLM is often as simple as providing translations for the various messages and strings which the user interface of a HotDocs interview may require.

Loading the Language Module

Since HotDocs BLMs are JavaScript objects, loading them means ensuring that you load an object with the expected properties and methods into the scripting environment where HotDocs is expecting to find it. You can do this either by loading a language module using a <script> tag in the page containing the HotDocs Server interview, or by declaring that language module in-line in the page. Either way, HotDocs Server interviews expect you to define any language modules as part of the HOTDOC$.Locales associative array. You can declare a new language module as part of this array using a script such as this:

// Either use the existing array or create a new one if it is not yet defined in the global scope.

var HOTDOC$ = window.HOTDOC$ || {};

// Register the new language module with the HotDocs locale infrastructure.

if (!HOTDOC$.Locales)

HOTDOC$.Locales = {};

// Add a new language module definition to the array.

HOTDOC$.Locales["de-DE"] = {

name: "German (Germany)"

// See below for additional properties and functions to define.

};

This code does not require that you load any HotDocs Server-related code before it is executed, so you can run it at any stage of initialization or page loading. The only requirement is that you load and execute it before the HotDocs Server interview itself starts up.

Declaring the Interview Locale

We recommend (but don't require) that you explicitly declare a locale for a HotDocs Server interview. The locale informs the HotDocs Server interview that numeric and date input should (if possible) adhere to the norms for the declared locale, and dictates which set of translated user interface strings to use. You can declare the locale by setting a global variable in the JavaScript environment called HDInterviewLocale.

Once HotDocs Server determines the locale, it will attempt to find a loaded BLM representing that locale. If one cannot be found, HotDocs Server will still attempt to do its best with interpreting or formatting numbers and dates according to the requested locale. Also, if text strings for the requested locale are not available, HotDocs Server attempts to find them in each successive parent locale, or it uses US English text if nothing else is found.

If you do not declare an interview locale, HotDocs Server will do its best to detect the end-user’s system locale automatically at runtime; otherwise, it will default to the US English ("en-US") locale.

Interview Locale vs. Assembled Document LANGUAGE

HotDocs continues to support the LANGUAGE keyword in templates to determine how it should format dates and numbers in assembled (output) documents. The new interview locale for HotDocs Server browser interviews is completely independent from the functionality associated with the LANGUAGE keyword—a BLM has no effect on the assembled document, and a LANGUAGE keyword has no effect on the interview. If you want to produce interviews and documents in languages other than English, you must use both features together.

Although you can use the interview locale and a matching BLM to specify the language used for the standard user interface elements, the prompts, dialog titles, and other template-specific text in the interview must still be specified separately by the template author. HotDocs does not have a way to specify multiple prompts (in different languages) for a single variable, but some users have achieved this functionality using a combination of variable fields in prompts and different overlay answer files that provide translated text for each language.

Definition of a Browser Language Module

Following is the JSON notation for an example browser language module:

This is an incomplete implementation of a "de-DE" BLM. It provides translations for month and day names, as well as "yes" and "no" used in True/False variables. All other text would be rendered using US English by default. Likewise, all date and number formatting would be done using the default English implementations since this BLM does not contain any definitions for locale-specific formatting methods.

{

name: "German (Germany)",

dateOrder: "DMY",

months: ["Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"],

monthsShort: ["Jan", "Feb", "Mär", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez"],

days: ["Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"],

daysShort: ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"],

calWeekBegin: 1,

calWeekend: [0, 6],

zeroFormats: ["Null"],

numSeps: [",", "."],

strings: { ui_yes: "Ja", ui_no: "Nein" },

SpellNum: function(value, strZero, bOrdinal){}

}

Creating a Browser Language Module

For information on creating a Browser Language Module, see:

  • How to create a Browser Language Module
  • Browser Language Module Reference


Create a Browser Language Module

The Browser Language Module is a specification in the HotDocs JavaScript API that allows developers to localize the HotDocs interview. This means that you can present the user interface in a language other than US English. By following the specification, you can define a language module which allows HotDocs Server to present an interview in any language.

To add a new Browser Language Module

  1. Create a new JavaScript (.js) file that includes all of the necessary scripting for your language module. You can see a complete example below. Place this file in a directory that is accessible by Workspace. For this example, place the JavaScript file in the Workspace Scripts directory (by default: C:\Program Files\HotDocs Limited\HotDocs Workspace\Default\Content\Scripts).

See Browser Language Module Reference for a full list of all methods and attributes available to Browser Language Modules.

  2. Navigate to your Workspace installation directory and find the Interview.Master file. By default, you can find this in C:\Program Files\HotDocs Limited\HotDocs Workspace\Default\Views\Shared. Edit the file in a text editor, such as Notepad.
  3. For HotDocs Server to recognise that the user has defined a Browser Language Module and it should override the default language setting, you must set the HDInterviewLocale global variable on the page in which the interview is run. In the Interview.Master file, insert <script type="text/javascript">HDInterviewLocale = "de-DE";</script>. Notice that Server sets the HDInterviewLocale variable to the name of the language type in the HOTDOC$.Locales array (i.e. HOTDOC$.Locales["de-DE"]).
  4. Inside the <head>...</head> tags in Interview.Master, insert a reference to the JavaScript file created in Step 1. For example: <script src="<%= ResolveUrl("~/Content/Scripts/ws_language.js") %/>" type="text/javascript" />.

Example

// Either use the existing array or create a new one if it is not yet defined in the global scope.

var HOTDOC$ = window.HOTDOC$ || {};

// Register the new language module with the HotDocs locale infrastructure.

if (!HOTDOC$.Locales)

HOTDOC$.Locales = {};

// Add a new language module definition to the array.

HOTDOC$.Locales["de-DE"] = {

name: "German (Germany)",

dateOrder: "DMY",

months: ["Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"],

monthsShort: ["Jan", "Feb", "Mär", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez"],

days: ["Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"],

daysShort: ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"],

calWeekBegin: 1,

calWeekend: [0, 6],

zeroFormats: ["Null"],

numSeps: [",", "."],

strings: { ui_yes: "Ja", ui_no: "Nein" },

SpellNum: function(value, strZero, bOrdinal){}

}


Language Module Strings

The following tables list all of the strings that you can localize in a Browser Language Module (BLM):

Standard User Interface Elements

String | Default Text (English) | Usage
ui_hd | HotDocs | This is used in the title bar of error message boxes (where possible)
ui_logo | Powered by HotDocs Server |
ui_load | Loading HotDocs interview... |
ui_wait | Please Wait |
ui_help | HotDocs Server Help |
ui_helpcaption | Help |
ui_io | Interview Outline |
ui_yes | Yes |
ui_no | No |
ui_other | Other |
ui_nota | None of the Above |
ui_cal | Calendar |
ui_ssbedit | Edit Ro&w | If this string contains an ampersand, Server interprets the following character as a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
ui_ssbins | &Insert Row | If this string contains an ampersand, Server interprets the following character as a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
ui_ssbdel | &Delete Row | If this string contains an ampersand, Server interprets the following character as a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
ui_rownum | [Row {0}] | This is appended to the dialog title during "Edit Row" operations
ui_rownew | [New Row] | This is appended to the dialog title during "Edit Row" operations
ui_new | New | This is a prefix for new, unanswered dialog iterations
ui_rtntiv | Back to Interview |
ui_sresult | Server Results | This is the default title for the "Server Results" pane, which is visible when using the HDPostAnswersToServer or HDPostToServer functions.
ui_addbtn | &Add Another | If this string contains an ampersand, Server interprets the following character ass a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
ui_mnutt | Dialog Menu |
ui_err | Error |
ui_close | Close |

Formatting Strings

String | Default Text (English) | Usage
ui_and | and |
ui_or | or |
ui_minus | minus |
ui_percent | percent |
ui_true | true |
ui_false | false |

Answer Summaries

String | Default Text (English) | Usage
ui_as | HotDocs Answer Summary | This is the title used for answer summaries when printing.
ui_astitle | Template: |
ui_print | Print |

Toolbar Button Tooltips and Status Bar Messages

String | Default Text (English) | Usage
tb_as | Answer Summary |
tb_ast | Display a summary of all answers entered in this interview. |
tb_sv | Save Answers |
tb_svt | Save the current answers. |
tb_dp | Document Preview |
tb_dpt | Display an approximate preview of the finished document. |
tb_ol0 | Hide Interview Outline |
tb_ol1 | Show Interview Outline |
tb_ol2 | Show/Hide Interview Outline |
tb_ol3 | Show Drop-down Interview Outline |
tb_olt | Toggle the Interview Outline on or off. |
tb_od | Show Interview Outline |
tb_odt | Show the Interview Outline drop-down. |
tb_iu0 | Disable Instant Update |
tb_iu1 | Enable Instant Update |
tb_iut | Toggle Instant Update of interview outline on or off. |
tb_pg0 | Multi-page Interview |
tb_pg1 | Single-page Interview |
tb_pgt | Toggle between Multi-page and Single-page interview. |
tb_rs0 | Hide Resource Pane |
tb_rs1 | Show Resource Pane |
tb_rst | Toggle between showing resources in Pop-up windows or the Resource Pane. |
tb_hlp | Display the HotDocs Server help page. |

Dialog Navigation

String | Default Text (English) | Usage
navb_First | Fi&rst | If this string contains an ampersand, Server interprets the following character as a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
navb_Prev | &Previous | If this string contains an ampersand, Server interprets the following character as a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
navb_Next | &Next | If this string contains an ampersand, Server interprets the following character as a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
navb_Last | &Last | If this string contains an ampersand, Server interprets the following character as a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
navb_Finish | Finish | If this string contains an ampersand, Server interprets the following character as a keyboard access shortcut in JavaScript interviews. (In Silverlight interviews, the ampersand will simply be omitted since they do not support keyboard shortcuts.)
nav_First | First Dialog |
nav_PrevU | Previous Unanswered Dialog |
nav_Prev | Previous Dialog |
nav_Next | Next Dialog |
nav_NextU | Next Unanswered Dialog |
nav_Last | Last Dialog |
nav_Finish | Finish Interview | Tooltip for the "Finish" button
nav_FinEM | Finish Editing Rows / Return to List | Tooltip for the "Finish Edit Mode" button
nav_leave | This will terminate the interview, and any answers you have entered will be lost. Click the Next or Previous buttons at the bottom of the page to move through the interview. If you are finished answering questions, click Finish to complete the interview and submit your answers. |
nav_warnfin | This is the last dialog in the interview. Click OK if you are finished with the interview and want to submit your answers. Click Cancel to return to the interview. |

Keyboard Accelerator Tooltips

String | Default Text (English) | Usage
uitt_First | First Dialog (Ctrl+Home) |
uitt_PrevU | Previous Unanswered Dialog (Ctrl+Page Up) |
uitt_Prev | Previous Dialog (Page Up) |
uitt_Next | Next Dialog (Page Down) |
uitt_NextU | Next Unanswered Dialog (Ctrl+Page Down) |
uitt_Last | Last Dialog (Ctrl+End) |
uitt_ssbedit | Edit Row (Ctrl+Enter) |
uitt_ssbins | Insert Row (Ctrl+Insert) |
uitt_ssbdel | Delete Row (Ctrl+Delete) |

HotDocs Resources

String | Default Text (English) | Usage
rs_bcap | View Resource |
rs_dis | See individual {0} for available resources |
rs_cols | columns |
rs_opts | options |
rs_opt | option |
rs_fld | answer field |
rs_dlg | dialog |
rs_ind | {0}{1}{2} for {3} | {0} & {2} are begin/end hyperlink markup, {1} is [rs_bcap], {3} is [rs_opt]/[rs_fld]/[rs_dlg].

Validation Messages

String | Default Text (English) | Usage
val_invdate | Please enter a valid date. |
val_invnum | Please enter a number. |
val_numrng | Please enter a number between {0} and {1}. |
val_numlt | Please enter a number that is less than or equal to {0}. |
val_numgt | Please enter a number that is greater than or equal to {0}. |
val_reqg | One or more questions are required and must be answered before you can complete the interview. |
val_reqp | One or more questions are required and must be answered before you can proceed. |
val_reqd | One or more questions in the {0} dialog are required and must be answered before you can proceed. |
val_rptlim | You can enter only {0} sets of answers for this dialog. |
val_repdel | Are you sure you want to delete this repetition? |
val_err | You must resolve one or more input errors before you can proceed. |
val_wait | Please wait while your answers are being processed. |

Context Menu

String | Default Text (English) | Usage
hdmnuClearAns | Erase Answer |
hdmnuCut | Cut |
hdmnuCopy | Copy |
hdmnuPaste | Paste |
hdmnuDel | Delete |
hdmnuSelAll | Select All |
hdmnuEditRow | Edit Row |
hdmnuInsRow | Insert Row |
hdmnuDelRow | Delete Row |
hdmnuMoveRowUp | Move Row Up |
hdmnuMoveRowDn | Move Row Down |
hdmnuClearDlg | Erase Answers |
hdmnuInsRep | Insert Repetition |
hdmnuDelRep | Delete Repetition |
hdmnuMoveUp | Move Repetition Up |
hdmnuMoveDn | Move Repetition Down |
hdmnuNewRep | New Repetition |
hdmnuEraseAllAns | Erase All Answers |

Date Input Parsing Regular Expressions

HotDocs Server interviews support simple TODAY-based date arithmetic when entering a date. For example, if you want to enter today's date plus 4 days, you could enter "T + 4 days" in the date field and it would be interpreted as the date four days after today. The following strings allow you to localize the keywords used to interpret such date arithmetic; Server parses date expressions using a regular expression built using these strings: ^{dateparse_today}\s*([+-])\s*(\d+)\s*({dateparse_days}|{dateparse_months}|{dateparse_years})$

String | Default Text (English) | Usage
dateparse_today | (t|today) | This expression allows users to enter a "T" or "TODAY" as a shortcut to today's date.
dateparse_days | (d|day|days) | This expression allows users to enter "d", "day", or "days" to add a number of days to TODAY.
dateparse_months | (m|month|months) | This expression allows users to enter "m", "month", or "months" to add a number of months to TODAY.
dateparse_years | (y|year|years) | This expression allows users to enter "y", "year", or "years" to add a number of years to TODAY.

User-Facing Error Messages

String | Default Text (English) | Usage
err_invint | Invalid Interview: The current dialog cannot be displayed!<br>&nbsp;<br>You may still click the Finish button below if you want to<br>submit the results of this interview. |
err_vers | This HotDocs interview (HDVers={0}) is incompatible with the current HotDocs Server interview runtime ({1}). |
err_slv | This HotDocs Server interview requires Microsoft Silverlight version 3.0 or later. |
err_load | Error: {0} failed to load properly. |
err_noint | Invalid Interview: There is nothing to display! |
err_print | Printing failed due to your browser's security restrictions. |
err_mustret | You must return to the interview before performing this action. |
err_rowclck | Please click in a table cell to choose a current row. |
err_nest | Invalid Interview: REPEAT instructions are nested more than 4 levels deep. |
err_cantadd | You must answer at least one question in this dialog before you can add another dialog. |
err_brows | Browser Error |
err_browsm | You are attempting to use a HotDocs Server interview on an unsupported browser or platform; the interview may not appear correctly. Continue anyway? |
err_browssl | HotDocs Server Silverlight interviews are only supported in Internet Explorer, Firefox and Safari web browsers running on Windows or Mac systems. |
err_browsjs | HotDocs Server JavaScript interviews require Microsoft Internet Explorer 6.0 or later. |
err_unk | Unknown Error |

Internal Error Messages

Since these internal error messages should appear rarely in well-tested templates, you may wish to skip them when creating your language module.

String | Default Text (English) | Usage
errnoact | Interview could not be initialized: FormAction not specified. |
errpath | Interview could not be initialized: no {0} path was specified. |
errdiv | Error: Unable to render HotDocs interview because the interview container (hdMainDiv) does not exist on this page. Please contact your network administrator. |
errinit | Error: Interview attempted to start before initialization was complete. Please report situation to HotDocs development. |
errslimg | Silverlight supports only PNG and JPG images. Has an invalid or missing image file been used? |
errpoprslt | Error: Attempted to pop an empty result stack. |
errsetrslt | Error: Attempt to set the top of an empty result stack. |
errgetrslt | Error: Attempt to get the top of an empty result stack. |
errpopuans | Error: Attempted to pop an empty unanswered stack. |
errsetuans | Error: Attempt to set the top of an empty unanswered stack. |
errgetuans | Error: Attempt to get the top of an empty unanswered stack. |
errpop | {0}: Pop of empty stack! |
errget | {0}: Get on empty stack! |
badmojo | Bad Mojo {0}: {1}! |
errpoprpt | Error: Unable to pop an empty repeat stack. |
erraccrpt | Error: Unable to access the top of an empty repeat stack. |
errinfunc | Error in {0}: {1} |
vnf | Var not found! |
badcomp | Inappropriate comparison. |
txtcomp | Inappropriate text comparison. |
datecomp | Inappropriate date comparison. |
tmccomp | Error: Invalid text-to-MC comparison. |
mccomp | Invalid MC to MC comparison. |
dateop | Error: Inappropriate operation on a date variable. |
badtest | Error: Testing an invalid variable or one that does not exist. |
badcount | Error: Invalid item passed to HDCount. |
baddateof | Error: Invalid date used in \"DATE OF\" calculation. |


Browser Language Module Reference

Language Module Properties

The following table lists the properties you can specify in your language module:

Name | Description | Example
name | A name for the language module (it is not currently used in the user interface). | German (Germany)
dateOrder | Determines the default date order: DMY (Day Month Year), MDY (Month Day Year), or YMD (Year Month Day). | DMY
months | An array of full month names. | ["Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"]
monthsShort | An array of abbreviated month names. | ["Jan", "Feb", "Mär", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez"]
days | An array of full day names, beginning with Sunday. | ["Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"]
daysShort | An array of abbreviated day names (used in the header row in the calendar). | ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"]
calWeekBegin | A number to indicate the first calendar day of the week, where Sunday is 0. | 1
calWeekend | An array containing the numeric values for the days that constitute a calendar weekend, where Sunday is 0. | [0, 6]
zeroFormats | An array of words used to spell out the number 0 (zero). | ["Null"]
numSeps | An array containing number separators: the decimal separator followed by the thousands separator. | [",", "."]
strings | An associative array of translated user interface text. For a complete list of strings that you can localize, see Language Module Strings. | { ui_yes: "Ja", ui_no: "Nein" }

Language Module Methods

The following table lists the methods you can implement in your language module to handle date and number formatting:

If you have appropriately set all the regular properties of the language module, and assuming you are running the interview in either Silverlight or in Internet Explorer JavaScript, the default (US English) implementation of the methods should mostly suffice for most languages. The only methods that you may need to implement for full functionality in this case are:
• SpellNum: If omitted, numbers aren't spelled out, but are displayed numerically instead.
• GetOrdinalSuffix: If omitted, ordinals are produced.
• InterpretSpelledNum: If omitted, traditional HotDocs-style number & date format examples may not work fully.

Name | Description | Function Signature
SpellNum | This function takes an integer (value) and spells out the number in text (e.g., "three"), using strZero in place of zero and honoring bOrdinal. | function(value, strZero, bOrdinal) {}
GetOrdinalSuffix | This function returns the appropriate ordinal suffix for an integer value. | function(value) {}
IsOrdinalSuffix | This function determines whether str begins with an appropriate ordinal suffix for value. If so, it returns how many characters of str constitute that suffix. | function(value, str) {}
ParseNumLoc | This function parses a string (str) to create a double value, which is returned. (If str cannot be interpreted as a number, it should return NaN instead.) | function(str) {}
ParseDateLoc | This function parses a string (str) to create a JavaScript Date object, which is returned. (If str) cannot be interpreted as a date, it should return null instead.) | function(str) {}
FormatNumLocDef | This function is used when a number needs to be formatted and no format example was recognized. It takes a double (value) and formats it according to locale conventions into a string, padding decimals out to the specified number of decimal places (nDecPlaces). | function(value, nDecPlaces) {}
FormatNumLoc | This function takes a double (value) and formats it according to the specified parameters: number of decimal places (nDecPlaces), whether or not to include the thousands separator (bThousandsSep), whether or not to zero-pad (bZeroPad), and whether or not to use native digits (bNativeDigits). | function(value, nDecPlaces, bThousandsSep, bZeroPad, bNativeDigits) {}
FormatDateLoc | This function is used when a date needs to be formatted and no format example was recognized. It takes number values for day (d), month (m), and year (y), and formats a date according to locale conventions—either full-length or abbreviated depending on the value of bLong. | function(d, m, y, bLong) {}
FormatTextVal | This function parses the given HotDocs format example (formatExample) and formats the text value accordingly. | function(value, formatExample) {}
FormatNumVal | This function parses the given HotDocs format example (formatExample) and formats the number value accordingly, out to the specified number of decimal places (decimalPlaces). | function(value, formatExample, decimalPlaces) {}
FormatDateVal | This function parses the given HotDocs format example (formatExample) and formats the date value accordingly. | function(value, formatExample) {}
FormatTFVal | This function parses the given HotDocs format example (formatExample) and formats the boolean value accordingly. | function(value, formatExample) {}
FormatList | This function parses the given HotDocs format example (formatExample) and formats the list of values in valueArray accordingly. | function(valueArray, formatExample) {}

See also

•Browser Language Module Strings


Upload Limit

In the Workspace web.config file, the following line controls the maximum upload limit when publishing templates to Workspace:

<httpRuntime maxRequestLength="32768" requestLengthDiskThreshold="4096" />

You can edit the sizes for maxRequestLength and requestLengthDiskThreshold to increase or decrease the upload limit. If the upload limit is exceeded during an upload action, Workspace produces an error message.

By default, the maximum request length is set to 32768kB (32MB). We recommend that the upload limit for Workspace be kept low, to minimize security risks to the server.


Custom Error Pages

In the Workspace Web.config file, you can use the <customErrors> section to configure the behavior of Workspace when an unhandled error occurs during the execution of a request. Specifically, it enables developers to configure html error pages to be displayed in place of an error stack trace.

<customErrors mode="On" defaultRedirect="~/Error">

<error statusCode="403" redirect="~/Error/NoAccess" />

<error statusCode="404" redirect="~/Error/NotFound" />

</customErrors>

To turn custom error pages off, set customErrors mode to Off.


Copy Work Item

In the Workspace Web.config file, you can use the <AllowCopy> property in the FDPConfiguration section to turn on the option for users to copy work items. This displays a button on the Work Item list and Work Item Details pages.

<FdpConfiguration
 TemplatePath="" DocumentPath="" AnswersPath=""
 MappingPath="" UsersShareWorkItems="false" AllowCopy="false"
 MinRequiredPasswordLength="6" AllowedFileExtension=".hdpkg"
 CachePath="" />

To turn on the copy work item function, set allowCopy to true.

By default, this function is turned off in Workspace.


Users Share Work Items

In the Workspace Web.config file, the <UsersShareWorkItems> property in the FDPConfiguration section allows users to see every Work Item in a group, regardless of whether they created the work item themselves.

<FdpConfiguration
 TemplatePath="" DocumentPath="" AnswersPath=""
 MappingPath="" UsersShareWorkItems="false" AllowCopy="false"
 MinRequiredPasswordLength="6" AllowedFileExtension=".hdpkg"
 CachePath="" />

To turn on the users share work items function, set UsersShareWorkItems to true. Otherwise users will only ever see their own Work Items when accessing a group.

By default, this function is turned off in Workspace.


Logging

In the Workspace Web.config file, you can use the FdpLoggingConfiguration section to configure the logging used in Workspace. Specifically, it allows administrators to enable or disable the writing of Workspace events (for example, when an administrator creates a new user or uploads a template) to a log file. To turn on logging, set the UseLogging attribute to true. To turn logging off, set UseLogging mode to false.

<FdpLoggingConfiguration UseLogging="false">

When UseLogging is set to true, a Statistics page appears in the navigation bar for all administrators. Here they can see the number of users, templates and work items created in Workspace. There can also see the last ten entries written to the log file.

By default, logging is turned off in Workspace.


Set up NTLM authentication on your server

The steps below are to be used as a guide for setting up NTLM authentication for HotDocs Workspace as there may be variations between different servers.

1. Edit User Details

Before editing any setting in your server we recommend you first change all of your users over to NTLM authentication within Workspace so you are able to immediately access Workspace once you have completed the set up. You need to set up one local user (usually an admin) for the server and then you can set up remote users.

  1. In the Navigation bar The Navigation bar is the top-level navigation menu, linking to the main sections of Workspace. It appears on every page of Workspace. Clicking on a link in the navigation bar takes the user to the selected Section. of Workspace, click Users.
  2. Click the Edit button next to the user you wish to edit.
  3. Check the box next to User is NTLM User.
  4. In the NTLM Name text box type:
    1. For a local user: the server name followed by a backslash and their username on the server e.g. servername\Administrator
    2. For a remote user: their domain followed by a backslash and their username for that domain e.g. domainname\johndoe

  5. Click Save.

  6. Repeat for every remote user.

2. Edit Web Config file

You need to make two changes to the Web Config file to allow NTLM authentication.

Both settings are case sensitive.

  1. Locate the line <FdpNtlmConfiguration EnableNtlm="false"/> and change the attribute to "true".
  2. Locate the line <authentication mode="Forms"> and change the attribute to "Windows".
  3. Save and close.

3. Edit IIS configuration

  1. Open IIS Manager.
  2. In the connections pane, expand the connections until you get to the Workspace site level (e.g. ServerName>Sites>Default Web Site>Workspace)
  3. Double click on Authentication.
  4. Windows Authentication needs to be enabled and Forms Authentication and Anonymous Authentication need to be disabled.

If Windows Authentication is not available:

  1. Open Server Manager.
  2. Expand Roles in the left pane and right click on Web Server (IIS).
  3. Select Add Role Services.
  4. Under Security, check the box next to Windows Authentication.
  5. Click Next and then Install.

You may need to restart your server for Windows Authentication to be available in IIS Manager.

Final steps

If your server is not already part of the domain you used for remote user NTLM names in section 1:

  1. Open Control Panel.
  2. Open System.
  3. Under Computer name, domain and workgroup settings, click Change Settings.
  4. On the Computer Name tab click Change.
  5. Make sure the radial button for Domain is checked, then enter the Domain name in the text box below.


Contact HotDocs Sales and Support

HotDocs Technical Support

Support for customers with technical support agreements is available by calling the numbers below. To expedite your call, please be at the computer on which the program is running.

Outside the European Union:

Method of Contact | Information
Telephone | (800) 828-8328 (U.S.) (801) 615-2200 (International) U.S. technical support is available from 7:00am to 6:00pm (MST), Monday through Friday.
E-mail | support@hotdocs.com
Web Site | http://www.hotdocs.com/support/

Inside the European Union:

Method of Contact | Information
Telephone | 0843 208 0704 (U.K.) +44 131 226 3999 (International) U.K. technical support is available from 9:00am to 5:00pm (GMT), Monday through Friday.
E-mail | tech@hotdocs.co.uk
Web Site | http://www.hotdocs.co.uk

You may also find answers or solutions to questions you have in the HotDocs Wiki. To view the Wiki (as well as access other support options), please visit http://wiki.hotdocs.com.

Click here for information on providing the HotDocs Publications team with documentation feedback.

HotDocs Sales Support

Experienced HotDocs consultants are available to help you with a variety of services, including integrating HotDocs with other products, building a template library, or providing training. Please contact your sales representative to learn more.

Outside the European Union:

Method of Contact | Information
Telephone | (800) 500-3627 (U.S. Sales) (801) 615-2200 (U.S. Business) +44 131 226 3999 (International)
Fax | (877) 356-3627 (U.S.) (801) 868-3627 (International)
E-mail | sales@hotdocs.com
Web Site | http://www.hotdocs.com http://www.hotdocs.com/products http://www.hotdocs.com/services
Address | 387 South 520 West Suite 210 Lindon, Utah 84042

Inside the European Union:

Method of Contact | Information
Telephone | 0131 226 3999 (U.K.) +44 131 226 3999 (International)
Fax | 0131 220 9024 (U.K.) +44 131 220 9024 (International)
E-mail | info@hotdocs.co.uk
Web Site | http://www.hotdocs.co.uk
Address | 14 South Charlotte Street Edinburgh, EH2 4AX Scotland


Documentation Feedback

To improve the quality of the tutorials and the help files, we invite you to make comments or suggestions. When doing so, please include as much information about your experience using the documentation as possible. For example, include which version of the product you are using, as well as whether your suggestion is in regards to the Installation Guide and Tutorial or the electronic help file. If commenting about a specific topic, include that information as well.

The HotDocs Publications team cannot respond to technical support or project consulting questions. We are mainly interested in problems with the documentation itself—such as erroneous information, grammatical and spelling errors, or suggestions for topics to include in the next release of the software.

E-mail your comments and suggestions to publications@hotdocs.com.


Copyright Information

Copyright

Copyright © 2014 HotDocs Limited.

All rights reserved. No part of this product may be reproduced, transmitted, transcribed, stored in a retrieval system, or translated into any language in any form by any means without the express written permission of HotDocs Limited ("HotDocs").

Warranty Information

HotDocs makes no representations or warranties with respect to the contents or use of this product and specifically disclaims any express or implied warranties of merchantability or fitness for any particular purpose. Information in this document is subject to change without notice and does not represent a commitment on the part of HotDocs.

Government Use

Use, duplication, or disclosure by the Federal Government is subject to restrictions as set forth in FAR clauses 52.227--14, “Rights in Data--General”; 52.227--19, “Commercial Computer Software--Restricted Rights”; and subdivision (c)(1)(ii) of the Rights in Technical Data and Computer Software clause DFAR 252.227--7013; and the limitations set forth in the standard commercial license agreement for this software. Unpublished rights are reserved under the copyright laws of the United States.

Trademark Information

HotDocs is a registered trademark of HotDocs Limited. Other product names may be trademarks or registered trademarks of their respective companies.


Getting Started: Home Page

Home Page

Upon login, the Home Page appears. On this page, you can use the My Groups drop-down list to view the groups the Workspace Administrator has assigned you. You can click on a group to view the list of Work Items associated with that group, each of which contains at least one assembled Document A Document is an assembled template, with an associated set of answers, contained within a Work Item. A work item may contain several different documents. A document can be downloaded as a Microsoft Word file (or a PDF, if your system has been configured with this capability) from a link inside its work item.. The Workspace Administrator can customize work items to reflect the kind of documents being produced. For example, a law firm might have work items called Estate Planning Package or Bankruptcy Forms to correspond to different areas of practice. Work items for a bank might be entitled Loan Package or Real Estate Transaction.

Navigation Bar

You can use the Navigation Bar, at the top of the page, to move between the main sections of Workspace. To use the navigation bar, click on a link to move to that area of Workspace.

Quick Search

You can use the Quick Search function to quickly search for Work Items, Users, Groups, and Templates in Workspace. The Quick Search is contextual: when used on the Home Page, the Quick Search will return results for work items. When used on the Templates page, the results will be for Templates.

To perform a search, type your search term into the quick search box. The results will filter automatically. To return to the full list of items, clear the Quick Search box.

Pagination

On the Home, Users, Groups, and Templates pages, there is a pagination control to limit or expand the entries shown on the screen.

To change the amount of items per page, use the Items per Page drop-down box on the right. You can browse through the pages by clicking the appropriate link after Pages on the left.


Getting Started with Workspace — Creating a new Work Item

Creating a new Work Item

You can create a new Work Item by clicking on the Create Work Item button below the My Groups drop-down list. From there, you can choose a template for assembly.

Next to each template are two icons:

  • Template Details — navigates to a description of the template.
  • Answer Upload — allows you to upload an existing Answer File to use with the template.

To begin assembling, click on your chosen template.


Getting Started with Workspace — Interview

Interview

By providing answers to the questions in the interview, Workspace is able to create a custom document using those answers and the template you previously selected. Once you have completed the interview, Workspace saves this document and it becomes available for download.

A HotDocs interview is a series of dialogs, each containing one or more questions. Workspace creates a custom document using your answers and the template you previously selected. Once you complete the interview, Workspace assembles the final customized document from the template by merging the interview answers into the template text.

The left pane of the interview window displays an outline of the interview. As the user answers questions, the outline tracks the user's progress through the interview.

At the top of the interview pane there are three buttons:

  • Document Preview- Displays a preview of the completed document.
  • Answer Summary- Displays a list of questions and answers from the interview.
  • Help- Displays a help page on completing the interview.

You can return to the interview from any of these pages by clicking Back to Interview.


Getting Started with Workspace — Return to Home Page

Return to Home Page

On returning to the Home Page, notice that Workspace has added the newly completed work item to the Work Items List. The items in the list can be sorted in ascending or descending order by clicking on the column headings.

You can click on the work item title to return to the Work Item Details page discussed in the previous topic or you can use the drop-down arrow on the right-hand side to quickly access the following options:

  • Update Interview — return to the current version of the work item and update the answers in the interview.
  • Download Assembly — download the assembled document for the currently selected version of the work item.

The Workspace Administrator can customize the table to provide further options here. They can choose to include the work item description, creation date, last modified date, last user, version number and the edit buttons that you can access on the Work Items Details page.

Previous Topic


Getting Started with Workspace — Work Item Details

Once you have finished the interview, Workspace displays the Work Item Details page. On this page, you can download the completed work item, edit it further, or switch to a different version of the work item.

Editing the Document

You can edit any version of an assembled document using the Edit Functions:

  • Add another document — Allows you to add a new template to the work item.
  • Edit title and description — Allows you to edit the Title and Description of a work item.
  • Export answers — Exports the answers from the document to a HotDocs Answer File (.anx).
  • Delete item — deletes the currently selected version of the work item.

Versions

Whenever you modify a work item, Workspace creates a new numbered Version of the work item. This enables you to keep track of changes made to a work item and to navigate between earlier and later versions of a work item, click the Version Navigation buttons: <, >.

Update the interview

Click [image] Update Interview to return to the current version of the work item and update the answers in the interview.

Downloading the completed document

Click [image] Download to download the assembled document for the currently selected version of the work item.

Below these options you can view the history of this work item. Once you have completed your work on this page, click Back to (group name) to return to the selected group on the Home Page.